=== debian/changelog ===
trojita (0.7-1) unstable; urgency=medium

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- pavroo <pavroo@onet.eu>  Mon, 24 Apr 2017 22:34:05 +0200
