=== debian/control ===
Source: trojita
Section: mail
Priority: optional
Maintainer: Jan Kundrát <jkt@kde.org>, pavroo <pavroo@onet.eu>
Build-Depends: debhelper (>= 9), cmake, qt5-default, qttools5-dev, qttools5-dev-tools, libqt5webkit5-dev, libqt5svg5-dev, zlib1g-dev, xvfb, xauth, qt5keychain-dev, libqt5sql5-sqlite, libkf5gpgmepp-dev, pkg-config, libmimetic-dev, gnupg2
Standards-Version: 3.9.6
Homepage: http://trojita.flaska.net/
Vcs-Git: git://anongit.kde.org/trojita
Vcs-Browser: https://projects.kde.org/projects/extragear/pim/trojita/repository

Package: trojita
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5-sqlite, libqt5svg5
Suggests: trojita-plugin-qtkeychain
Description: Trojita is a fast Qt IMAP e-mail client.
 Trojita is a Qt IMAP e-mail client which:
  * Enables you to access your mail anytime, anywhere.
  * Does not slow you down. If we can improve the productivity of an e-mail user, we better do.
  * Respects open standards and facilitates modern technologies. We value the vendor-neutrality that IMAP provides and are committed to be as interoperable as possible.
  * Is efficient — be it at conserving the network bandwidth, keeping memory use at a reasonable level or not hogging the system's CPU.
  * Can be used on many platforms. One UI is not enough for everyone, but our IMAP core works fine on anything from desktop computers to cell phones and big ERP systems.
  * Plays well with the rest of the ecosystem. We don't like reinventing wheels, but when the existing wheels quite don't fit the tracks, we're not afraid of making them work.

Package: trojita-plugin-qtkeychain
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A plugin for secure password storage for Trojitá
