=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

CXXFLAGS += $(CPPFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DQT_LCONVERT_EXECUTABLE=/usr/bin/lconvert \
	    -DCMAKE_INSTALL_PREFIX=/usr \
	    -DWITH_MIMETIC=ON -DWITH_GPGMEPP=ON -DWITH_CRYPTO_MESSAGES=ON \
	    -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_test:
	xvfb-run -a dh_auto_test

override_dh_auto_install:
	echo "usr/bin/trojita" > debian/trojita.install
	echo "usr/bin/be.contacts" >> debian/trojita.install
	echo "usr/share/applications/trojita.desktop" >> debian/trojita.install
	echo "usr/share/icons/hicolor/*/apps/*" >> debian/trojita.install
	echo "usr/share/trojita/locale/trojita_common_*.qm" >> debian/trojita.install
	echo "usr/share/appdata/trojita.appdata.xml" >> debian/trojita.install

ifndef DEB_HOST_MULTIARCH
	echo "usr/lib/libtrojita_plugins.so*" >> debian/trojita.install
	echo "usr/lib/trojita/trojita_plugin_QtKeychainPasswordPlugin.so*" > debian/trojita-plugin-qtkeychain.install
else
	echo "usr/lib/*/libtrojita_plugins.so*" >> debian/trojita.install
	echo "usr/lib/*/trojita/trojita_plugin_QtKeychainPasswordPlugin.so*" > debian/trojita-plugin-qtkeychain.install
endif
	dh_auto_install
